; dmagic.asm
; dumps C64 cartridges
; Version 1.00
; machine language part


* = $0801

.INCLUDE SYSTEM.ASM			; KERNAL functions

		.byte $26,$08,$0a,$00,$99,$22
		.text "DMAGIC CARTRIDGE DUMPER  V1.0"
		.byte $22,$00
		.byte $40,$08,$14,$00,$85,$22,$11
		.text "ENTER FILENAME"
		.byte $22,$3b,$4e,$24,$00
		.byte $4a,$08,$1e,$00,$9e,$32,$31,$32,$35,$00
;		.byte <_end,>_end,$28,$00,$00
		.byte $00,$00,$00
		
		JSR  _copyfilename
		JSR  _promptSwitch
		SEI
		JSR  _waitFire
		JSR  _busywait
		CLI

		LDA  #$00		; save first disk side
_saveL1		STA  _cartbank
		JSR  _copybank
		LDA  _cartbank
		CLC
		ADC  #$01
		CMP  #$04
		BNE  _saveL1

		JSR  _promptSave
		JSR  _waitFire
		JSR  _saveCart
		JSR  _promptDone
_the_end	JMP  _the_end
	

_cartbank	.byte 0


_copyfilename	LDY  #$02
		LDA  ($2d),Y
		STA  _namelen
		INY
		LDA  ($2d),Y
		STA  $fb
		INY
		LDA  ($2d),Y
		STA  $fc

		LDA  _namelen
		TAX
		LDY  #$00
_copyname	LDA  ($fb),Y
		STA  _filename,Y
		INY
		DEX
		BNE  _copyname

		RTS



_saveCart	JSR  CLRCHN
		JSR  CLALL
		LDA  #$01
		LDX  $ba		; FA - Use current Device Number
		TAY
		JSR  SETLFS		; SETLFS 1,8,1

		LDA  _namelen
		LDX  #<_filename
		LDY  #>_filename
		JSR  SETNAM
		LDX  #$00		; source memory $2000
		LDY  #$20
		STX  $fb
		STY  $fc
		LDA  #$fb
		LDX  #$00		; end of source memory $a000
		LDY  #$a0
		JSR  SAVE
		LDA  #$01
		JSR  CLOSE
		RTS

_namelen	.byte $00
_filename	.text "FILENAME GOES HERE"


_promptSwitch	JSR  $e544		; CLR
		JSR  $e566		; HOME
		LDY  #$00
_promptSwitchL1	LDA  _switch_text,Y
		BEQ  _promptSwitchJ1
		JSR  CHROUT
		INY
		BNE  _promptSwitchL1
_promptSwitchJ1	RTS


_promptSave	LDY  #$00
_promptSaveL1	LDA  _save_text,Y
		BEQ  _promptSaveJ1
		JSR  CHROUT
		INY
		BNE  _promptSaveL1
_promptSaveJ1	RTS

_promptDone	LDY  #$00
_promptDoneL1	LDA  _done_text,Y
		BEQ  _promptDoneJ1
		JSR  CHROUT
		INY
		BNE  _promptDoneL1
_promptDoneJ1	RTS


_busywait	LDA  #$10
		LDX  #$00
		LDY  #$00
_busywaitL1	DEY
		BNE  _busywaitL1
		DEX
		BNE  _busywaitL1
		CLC
		SBC  #$01
		STA  $d020
		BNE  _busywaitL1
		RTS

_switch_text	.text "PRESS <SPACE> KEY, THEN THROW SWITCH!"
		.byte 0

_save_text	.byte $0d,$0d
		.text "PLEASE INSERT SAVE DISK"
		.byte $0d
		.text "AND PRESS <SPACE> KEY!"
		.byte 0

_done_text	.byte $0d,$0d
		.text "DONE!"
		.byte 0


_waitFire	LDA  $dc00		; wait for fire button up
		AND  $dc01
		AND  #$10
		BEQ  _waitFire
_waitFireL1	LDA  $dc00		; wait for fire button
		AND  $dc01
		AND  #$10
		BNE  _waitFireL1
		RTS

_end		.byte $00,$00,$00



_copybank	LDA  _cartbank
		STA  $de00

		CMP  #$00
		BNE  _copyJ1
		LDY  #$00
		STY  $22
		STY  $24
		LDY  #$20
		STY  $25

_copyJ1		LDY  #$80
		STY  $23

		LDY  #$00
		LDX  #$20
_copyL1		LDA  ($22),Y
		STA  ($24),Y
		INY
		BNE  _copyL1
		INC  $23
		INC  $25
		DEX
		BNE  _copyL1
		
		RTS
